/*ghassan fakher
 * gkf01
 section 6*/

public class PeriodicTable {
	
	private Element[] elements;
	//constructor
	public PeriodicTable(String fileName)
	{
		In chemistry = new In(fileName);
		chemistry.readLine();
		int count = 0;
		while(!chemistry.isEmpty())
		{
			chemistry.readLine();
			count++;
		}
		chemistry = new In(fileName);
		elements = new Element[count];
		chemistry.readLine();
		for(int i = 0; i < count; i++)
		{
			elements[i] = new Element(chemistry.readString(), chemistry.readInt(), chemistry.readString(), chemistry.readDouble());
			chemistry.readLine();	//skip remainder
		}
	}
	//used to get the weight by calling other methods
	public double getMoleculeWeight()
	{
		StdOut.println("Type a name of a molecule such that there is a space between two elements; eg: H2 O");
		String molecule = StdIn.readLine();
		String[] split = molecule.split(" ");	//assuming that the user will put a space between the different atoms of the molecule; similar to the given example
		double weight = 0.;
		for(int i = 0; i < split.length; i++)
			weight += getBoth(split[i]);
		return weight;
	}	
	// splits between the coefficient and the element and uses them to compute the weight
	private double getBoth(String a)
	{
		String element = "";
		boolean found = false;
		int coefficient = 1;
		for(int i = 0; i < a.length() && !found; i++)
		{
			if(!(Character.isLetter(a.charAt(i))))
			{
				element = a.substring(0, i);
				found = true;
				coefficient = getCoefficient(a, i);
			}
			else
			{
				if(i < a.length() - 1)
				{
					if(Character.isLetter(a.charAt(i+1)))
						element = a.charAt(i) +"" + a.charAt(i + 1) + "";
					else
					{
						element = a.charAt(i)+"";
						coefficient = getCoefficient(a, i+1);
					}	
					found = true;
				}
				else
					element = a.charAt(i) + "";
			}
		}
		return findWeight(element, coefficient);
	}
	//returns the coefficient of each atom in the molecule
	private int getCoefficient(String a, int pos)
	{
		return Integer.parseInt(a.substring(pos, a.length()));
	}
	//computes the weight
	private double findWeight(String element, int coefficient)
	{
		double weight = 0.;
		boolean foundElementInTable = false;
		for(int i = 0; i < elements.length && !foundElementInTable; i++)
		{
			if(elements[i].getSymbol().equals(element))
			{
				weight = elements[i].getAtomicWeight();
				foundElementInTable = true;
			}
			
		}
		weight *= coefficient;
		return weight;
	}
	//returns a printed representation of the periodic table needed
	public String toString()
	{
		String allelements = "";
		for(int i = 0; i < elements.length; i++)
			allelements += elements[i] + "\n";
		return allelements;
	}
	//calls methods that are used to sort 
	public String[] sortElements()
	{
		System.out.print("Type the number of elements you want to sort: ");
		int length = StdIn.readInt();
		String[] molecules = new String[length];
		System.out.print("Randomly type the elements that you want to sort: ");
		for(int i = 0; i < length; i++)
			molecules[i] = StdIn.readString();
		Element[] moleculeElement = new Element[molecules.length];
		fillData(molecules, moleculeElement);
		sort(molecules, moleculeElement);
		return molecules;
	}
	//fills the array of elements with the elements of the String[] given by user
	private void fillData(String[] molecules, Element[] element)
	{
		
		for(int i = 0; i < molecules.length; i++)
		{
			for(int j = 0; j < elements.length; j++)
			{
				if(elements[j].getName().equals(molecules[i]))
					element[i] = elements[j];
			}
		}
	}
	//uses insertion sort according to atomic weight to sort elements in increasing order
	private void sort(String[] molecules, Element[] moleculeElement)
	{
		for(int i = 1; i < molecules.length; i++)
		{
			Element current = moleculeElement[i];
			int j = i - 1;
			while(j >= 0 && moleculeElement[j].getAtomicWeight() > current.getAtomicWeight())
			{
				molecules[j+1] = molecules[j];
				molecules[j] = current.getName();
				j--;
			}
		}
	}
}